package com.yeejoin.amos.fas.business.service.impl;

import java.io.File;
import java.io.IOException;
import java.util.Date;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Optional;
import java.util.Set;
import java.util.stream.Collectors;

import org.apache.commons.collections.CollectionUtils;
import org.assertj.core.util.Sets;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.util.ObjectUtils;
import org.springframework.web.multipart.MultipartFile;

import com.google.common.base.Joiner;
import com.google.common.collect.Lists;
import com.yeejoin.amos.fas.business.constants.FasConstant;
import com.yeejoin.amos.fas.business.dao.mapper.FireCarMapper;
import com.yeejoin.amos.fas.business.feign.RemoteSecurityService;
import com.yeejoin.amos.fas.business.param.CommonPageInfoParam;
import com.yeejoin.amos.fas.business.service.intfc.IFireCarService;
import com.yeejoin.amos.fas.exception.YeeException;
import com.yeejoin.amos.feign.privilege.model.DepartmentModel;


@Service("fireCarService")
public class FireCarServiceImpl implements IFireCarService {

	@Autowired 
	FireCarMapper fireCarMapper;
//	@Autowired 
//	IFireCarDao iFireCarDao;
	
	@Value("${windows.img.path}")
	private String winImgPath;

	@Value("${linux.img.path}")
	private String linuxImgPath;

	@Autowired
	private RemoteSecurityService remoteSecurityService;

//	public FireCar save(FireCar fireCar)
//	{
//		Long carId = fireCar.getId();
//		iFireCarDao.save(fireCar);
//		return fireCar;
//	}


//	public FireCar queryOne(Long id)
//	{
//		Optional<FireCar> FireCar1=	iFireCarDao.findById(id);
//		FireCar fireCar=null;
//		if(FireCar1.isPresent()){
//			fireCar=FireCar1.get();
//		}
//		return fireCar;
//	}

	public String [] delete(String []idArray) throws Exception
	{
//		for(String id:idArray)
//		{
//			Optional<FireCar> fireCar1 = iFireCarDao.findById(Long.parseLong(id));
//			FireCar fireCar=null;
//			if(fireCar1.isPresent()){
//				fireCar=fireCar1.get();
//			}
//			if(fireCar != null)
//			{
//				this.iFireCarDao.deleteById(Long.parseLong(id));
//			}else
//			{
//				throw new Exception("找不到指定的对象:"+id);
//			}
//		}

		return idArray;
	}



	@Override
	public Page<HashMap<String, Object>> queryFireCar(String toke,String product,String appKey,CommonPageInfoParam param) {
//		long total = fireCarMapper.countPageData(param);
//		List<HashMap<String, Object>> content = fireCarMapper.getFireCarPage(param);
//        if (!CollectionUtils.isEmpty(content)) {
//            Set<String> deptIds =  Sets.newHashSet(Lists.transform(content, Map->Map.get("dept_id")+""));
//            deptIds.remove("");
//            deptIds.remove(null);
//            if(!CollectionUtils.isEmpty(deptIds)){
//				List<DepartmentModel> depts =remoteSecurityService.listDepartmentByDeptIds(toke, product, appKey, Joiner.on(",").join(deptIds));
//				Map<Long, String>  deptMap = depts.stream().collect(Collectors.toMap(DepartmentModel::getSequenceNbr,DepartmentModel::getDepartmentName));
//				if (!ObjectUtils.isEmpty(deptMap)){
//					content.forEach(e -> {
//						e.put("departmentName",deptMap.get(Long.valueOf(e.get("dept_id").toString())));
//					});
//				}
//            }
//        }
//		Page<HashMap<String, Object>> result = new PageImpl<HashMap<String, Object>>(content, param, total);
		return null;
	}
	
//	@Override
//	public FireCarDetailVo findFireCarById(String toke,String product,String appKey,Long truckId) {
//		FireCarDetailVo carVo = fireCarMapper.getFireCarDetailById(truckId);
//		DepartmentModel departmentModel= remoteSecurityService.getDepartmentByDeptId(toke, product, appKey, carVo.getDeptId());
//		carVo.setDepartmentName(departmentModel != null ? departmentModel.getDepartmentName() : "");
//		return carVo;
//	}


//	@Override
//	@Transactional(rollbackFor = Exception.class)
//	public FireCar saveFireCarAndPhoto(FireCar fireCar, MultipartFile[] files) {
//		Long carId = fireCar.getId();
//		fireCar.setCreateDate(new Date());
//		fireCar = iFireCarDao.saveAndFlush(fireCar);
//		String photoPath = "";
//		for (int i = 0; i < files.length; i++) {
//			MultipartFile file = files[i];
//			if (file.isEmpty()) {
//				continue;
//			}
//			String path = FasConstant.UPLOAD_ROOT_PATH + File.separator + FasConstant.UPLOAD_CAR_PATH + File.separator + fireCar.getId();
//			String filePath = getRootPath() + path;
//			String fileName = File.separator + file.getOriginalFilename();
//			try {
//				File dest = new File(filePath + File.separator + fileName);
//				if (!dest.exists()) {
//					if (dest.getParentFile() != null && !dest.getParentFile().exists()) {
//						dest.getParentFile().mkdirs();
//					}
//					dest.createNewFile();
//				}
//				file.transferTo(dest);
//			} catch (IOException e) {
//				throw new YeeException("上传图片失败");
//			}
//			String photoFile = path + fileName;
//			if (photoPath != null && photoPath != "") {
//				photoPath += "," + photoFile;
//			} else {
//				photoPath = photoFile;
//			}
//
//		}
//		fireCar.setPhotoPath(photoPath);
//		iFireCarDao.save(fireCar);
//		return fireCar;
//	}
	
	private String getRootPath() {
		String localPath = "";
		if ("\\".equals(File.separator)) {
			localPath += winImgPath;
		} else if ("/".equals(File.separator)) {
			localPath += linuxImgPath;
		}
		return localPath.trim();
	}

}
